#WRITTEN BY DENE BOWDALO

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

#execute_S1.py

#Program that executes stage S1 of the GHOST pipeline

###--------------------------------------------------------------------------------------------------###
###IMPORT MODULES
###--------------------------------------------------------------------------------------------------###

from crossnetwork_processing_functions import create_GHOST_stage_logfile, get_run_dictionaries
import importlib
import inspect
import sys
import traceback

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

###--------------------------------------------------------------------------------------------------###
#Get root slurm job ID, active network/parameter/param_to_parallelise_by --> passed from job submittal script
###--------------------------------------------------------------------------------------------------###
slurm_job_ID, network, parameter, param_to_parallelise_by = sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4]

###--------------------------------------------------------------------------------------------------###
#import specific network processing module for network being processed
###--------------------------------------------------------------------------------------------------###
network_processor = importlib.import_module(network+'_processor')

###--------------------------------------------------------------------------------------------------###
#parse network data file/s --> if there is an error (uncaught internally), write an error log file
###--------------------------------------------------------------------------------------------------###
try:
    network_processor.read_data(slurm_job_ID, parameter, param_to_parallelise_by)
#write error log file if have uncaught internal error
except Exception as e:
    run_details, parameter_details, network_details = get_run_dictionaries(slurm_job_ID, network, parameter)
    log_file_str = inspect.trace()[-1][0].f_locals['log_file_str']
    log_file_str += str(traceback.format_exc())
    create_GHOST_stage_logfile('S1',run_details,3,log_file_str,param_to_parallelise_by)

###--------------------------------------------------------------------------------------------------###