#WRITTEN BY DENE BOWDALO

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

#execute_S2.py

#Program that executes stage S2 of the GHOST pipeline

###--------------------------------------------------------------------------------------------------###
###IMPORT MODULES
###--------------------------------------------------------------------------------------------------###

from crossnetwork_processing_functions import create_GHOST_stage_logfile, get_run_dictionaries, join_station_measurements
import inspect
import sys
import traceback

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

###--------------------------------------------------------------------------------------------------###
#Get root slurm job ID, active network/parameter/station_reference--> passed from job submittal script
###--------------------------------------------------------------------------------------------------###
slurm_job_ID, network, parameter, station_reference = sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4]

###--------------------------------------------------------------------------------------------------###
#join station specific files --> if there is an error (uncaught internally), write an error log file
###--------------------------------------------------------------------------------------------------###
try:
    join_station_measurements(slurm_job_ID, network, parameter, station_reference)
#write error log file if have uncaught internal error
except Exception as e:
    run_details, parameter_details, network_details = get_run_dictionaries(slurm_job_ID, network, parameter)
    log_file_str = inspect.trace()[-1][0].f_locals['log_file_str']
    log_file_str += str(traceback.format_exc())
    create_GHOST_stage_logfile('S2',run_details,3,log_file_str,station_reference)

###--------------------------------------------------------------------------------------------------###