#WRITTEN BY DENE BOWDALO

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

#execute_S5.py

#Program that executes stage S5 of the GHOST pipeline

###--------------------------------------------------------------------------------------------------###
###IMPORT MODULES
###--------------------------------------------------------------------------------------------------###

from crossnetwork_processing_functions import create_GHOST_stage_logfile, get_run_dictionaries, quality_control_processing
import inspect
import sys
import traceback

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

###--------------------------------------------------------------------------------------------------###
#Get root slurm job ID, active network/parameter/station_reference --> passed from job submittal script
###--------------------------------------------------------------------------------------------------###
slurm_job_ID, network, parameter, station_reference = sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4]

###--------------------------------------------------------------------------------------------------###
#Process specific station data through quality control checks --> if there is an error (uncaught internally), write an error log file
###--------------------------------------------------------------------------------------------------###
try:
    quality_control_processing(slurm_job_ID, network, parameter, station_reference)
#write error log file if have uncaught internal error
except Exception as e:
    run_details, parameter_details, network_details = get_run_dictionaries(slurm_job_ID, network, parameter)
    log_file_str = inspect.trace()[-1][0].f_locals['log_file_str']
    log_file_str += str(traceback.format_exc())
    create_GHOST_stage_logfile('S5',run_details,3,log_file_str,station_reference)

###--------------------------------------------------------------------------------------------------###