#WRITTEN BY DENE BOWDALO

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

#execute_T2.py

#Program that executes stage T2 of the GHOST pipeline

###--------------------------------------------------------------------------------------------------###
###IMPORT MODULES
###--------------------------------------------------------------------------------------------------###

from crossnetwork_processing_functions import create_GHOST_stage_logfile, get_run_dictionaries, concatenate_yearmonth_station_netCDFs
import inspect
import sys
import traceback

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

###--------------------------------------------------------------------------------------------------###
#Get root slurm job ID, active network/parameter/yearmonth_str/temporal_resolution_code --> passed from job submittal script
###--------------------------------------------------------------------------------------------------###
slurm_job_ID, network, parameter, yearmonth_str, temporal_resolution_code = sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5]

###--------------------------------------------------------------------------------------------------###
#Write netCDF for specific yearmonth, in specific output resolution, merging all relevant station specific data
#--> if there is an error (uncaught internally), write an error log file
###--------------------------------------------------------------------------------------------------###
try:
    concatenate_yearmonth_station_netCDFs(slurm_job_ID, network, parameter, yearmonth_str, temporal_resolution_code)
#write error log file if have uncaught internal error
except Exception as e:
    run_details, parameter_details, network_details = get_run_dictionaries(slurm_job_ID, network, parameter)
    log_file_str = inspect.trace()[-1][0].f_locals['log_file_str']
    log_file_str += str(traceback.format_exc())
    create_GHOST_stage_logfile('T2',run_details,3,log_file_str,'{}_{}'.format(yearmonth_str,temporal_resolution_code))

###--------------------------------------------------------------------------------------------------###