#WRITTEN BY DENE BOWDALO

###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###
    
#start_GHOST.py

#Program which begins execution of GHOST pipeline jobs for all defined networks/parameters

###--------------------------------------------------------------------------------------------------###
###IMPORT MODULES
###--------------------------------------------------------------------------------------------------###

from crossnetwork_processing_functions import create_greasy_arguments_file, submit_greasy_job
import numpy as np
import os
import shutil
import subprocess
import sys
import time

###--------------------------------------------------------------------------------------------------###
#Read configuration file
###--------------------------------------------------------------------------------------------------###
sys.path.append(os.getcwd())
from GHOST_configuration import *
###--------------------------------------------------------------------------------------------------###
###--------------------------------------------------------------------------------------------------###

#get slurm job ID --> passed from job submittal script
slurm_job_ID = sys.argv[1]

#compile run details dictionary from configuration file variables
run_details = {'start_date':start_date,'end_date':end_date,'ghost_version':ghost_version,'data_root':data_root,'process_root':process_root,'qos_pipeline':qos_pipeline,'qos_stage':qos_stage,'chunk_size':chunk_size,'job_array_limit':job_array_limit,'multithreading':multithreading,'networks':networks,'parameters':parameters,'temporal_resolutions':temporal_resolutions,'stages_to_process':stages_to_process,'slurm_job_ID':slurm_job_ID}

#make a copy of the configuration file indexed by the slurm job ID
shutil.copy2(process_root+'/run/GHOST_configuration.py',process_root+'/run/GHOST_configurations/configuration_{}.py'.format(slurm_job_ID))

#Iterate through defined networks/parameters
arguments = []

#Iterate through networks
for network in networks:

    #Iterate through parameters
    for parameter in parameters:

        #append current iterative arguments to arguments list
        arguments.append("{} {} {}".format(slurm_job_ID, network, parameter))

#create arguments file for all pipeline jobs in arguments list
create_greasy_arguments_file('pipeline',run_details,arguments)

#submit pipeline jobs (and monitor outcomes)
submit_greasy_job('pipeline','GPipe_{}'.format(slurm_job_ID),run_details)